import 'dart:async';

import 'package:circumstellar/circumstellar.dart';
import 'package:circumstellar/src/discord_client.dart';
import 'package:circumstellar/src/models/discord_objects/channels/base_channel.dart';
import 'package:circumstellar/src/models/discord_objects/message.dart';

class GuildTextChannel extends BaseChannel {
  GuildTextChannel.empty(DiscordClient client) : super.empty(client);

  static Future<GuildTextChannel> createFromData(
      Map<String, dynamic> json, DiscordClient client) async {
    var chan = new GuildTextChannel.empty(client)
      ..id = json['id']
      ..type = json['type']
      ..guildId = json['guild_id']
      ..sortingPosition = json['position']
      ..name = json['name']
      ..topic = json['topic']
      ..isNsfw = json['nsfw']
      ..lastMessageId = json['last_message_id']
      ..parentCategoryId = json['parent_id'];
    return chan;
  }

  // GuildTextChannel properties

  /// The ID of the guild this channel belongs to.
  String guildId = ""; // TODO: Guilds

  /// The position of this guild in the channel list (sorting position)
  int sortingPosition = 1;

  // TODO: Permission overwrites

  /// The name of this channel.
  String name = '';

  /// The topic of this channel.
  String topic = '';

  /// If this channel is NSFW (Not Safe For Work)
  bool isNsfw = false;

  /// The message ID of the last message sent to this channel.
  String lastMessageId = ''; // TODO: Implement this as a Message entity

  /// The ID of the parent category
  String parentCategoryId = '';

  // TODO: Last Pin Timestamps

  Future<RestRequestResult> createMessage(String content,
          {Map<String, dynamic> embed, bool tts, RequestOptions options}) =>
      this.client.createMessage(this.id, content,
          embed: embed, tts: tts, options: options);
}
