import 'dart:async';

import 'package:circumstellar/src/discord_client.dart';

abstract class Entity<TObjectId> {
  /// ID of this entity (usually a snowflake converted to a string)
  TObjectId id;

  /// The [DiscordClient] this entity belongs to.
  DiscordClient client;

  /// The raw data used to construct this entity.
  Map<String, dynamic> rawData;

  /// Creates an entity from a JSON map.
  Entity.fromData(this.rawData, this.client) {
    this.id = this.rawData['id'];
  }

  /// Creates a blank entity.
  Entity.empty(this.client);
}
