import 'dart:async';

import 'package:circumstellar/src/discord_client.dart';
import 'package:circumstellar/src/models/discord_objects/message.dart';

class EventDispatcher {
  DiscordClient _client;

  Future handleEvent(String eventName, dynamic data, bool isJsonObject) async {
    switch (eventName) {
      case 'READY':
        _readyController.add(null);
        break;
      case 'MESSAGE_CREATE':
        _messageCreateController
            .add(await Message.createFromData(data, _client));
        break;
      default:
        break;
    }
  }

  StreamController _messageCreateController = new StreamController.broadcast();
  Stream<Message> messageCreate = null;

  StreamController _readyController = new StreamController.broadcast();
  Stream<Null> ready = null;

  EventDispatcher(this._client) {
    this.messageCreate = _messageCreateController.stream;
    this.ready = _readyController.stream;
  }
}
